<template>
  <!-- 导入表 -->
  <el-dialog
    title="导入表"
    :visible.sync="visible"
    width="80%"
    top="5vh"
    v-loading="loading"
    append-to-body
  >
    <el-form :model="queryParams" ref="queryForm" :inline="true">
      <el-form-item label="表名称" prop="tableName">
        <el-input
          v-model="queryParams['query.tableName']"
          placeholder="请输入表名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>
    <el-row>
      <el-table
        @row-click="clickRow"
        ref="table"
        :data="dbTableList"
        @selection-change="handleSelectionChange"
        max-height="400px"
      >
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column
          prop="tableName"
          label="表名称"
          :show-overflow-tooltip="true"
        ></el-table-column>
        <el-table-column
          prop="tableComment"
          label="表描述"
          :show-overflow-tooltip="true"
        ></el-table-column>
        <el-table-column
          prop="createTime"
          :formatter="formatterDate"
          label="创建时间"
        ></el-table-column>
        <el-table-column
          prop="updateTime"
          :formatter="formatterDate"
          label="更新时间"
        ></el-table-column>
      </el-table>
    </el-row>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="handleImportTable">确 定</el-button>
      <el-button @click="visible = false">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import table from "@/assets/mixins/table";
export default {
  mixins: [table],
  data() {
    return {
      appId:null,
      loading: false,
      // 遮罩层
      visible: false,
      // 选中数组值
      tables: [],
      // 总条数
      total: 0,
      // 表数据
      dbTableList: [],
      // 查询参数
      queryParams: {},
    };
  },
  methods: {
    // 显示弹框
    show(appId) {
      console.log("importTable appId:" + appId);
      this.appId=appId
      this.queryParams["query.appId"] = appId;
      this.getList();
      this.visible = true;
    },

    
    clickRow(row) {
      this.$refs.table.toggleRowSelection(row);
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.tables = selection.map((item) => item.tableName);
    },
    // 查询表数据
    getList() {
      this.loading = true;

      let query = {};
      //判断追加百分号
      Object.assign(query, this.queryParams);

      if (query["query.tableName"] != null) {
        query["query.tableName"] = "%" + query["query.tableName"] + "%";
      }

      this.$post("/gentable/db/list", query)
        .then((res) => {
          if (res && res.code && res.code == 1) {
            this.dbTableList = res.data.result;

            this.loading = false;
          }
        })
        .catch((error) => {
          this.$message.error(error.message);
        });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      // this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 导入按钮操作 */
    handleImportTable() {
      console.log("handleImportTable appId:"+this.appId)
      this.$post("/gentable/importTable", {
        tables: this.tables.join(","),
        appId: this.appId,
      })
        .then((res) => {
          if (res && res.code && res.code == 1) {
            this.visible = false;
            this.$emit("ok");
          }
        })
        .catch((error) => {
          this.$message.error(error.message);
        });
    },
  },
};
</script>
